% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
if (nargin == 1)
    val = {{{'axes'}, {'matlab axes'}}};
    return;
else
    prop_name=varargin{1};
    switch prop_name
        case 'axes'
            val = self.axes;
        otherwise
            error(['Unknown property name ''' prop_name '''!']);
    end
end

