% Start matrix assembly.  The matrix is zeroed out.
%
% function retobj = start (self, nrows, ncols)
%
%   nrows=number of equations in rows
%   ncols=number of equations in columns; if ncols is not supplied, it is
%   taken to be the same as nrows
%
function retobj = start (self, nrows, ncols)
    if (~ exist('ncols','var'))
        ncols=nrows;
    end
    % this is just a placeholder, the matrix has not been initialized yet.
    self.mat = 0 * eye(nrows, ncols);
    retobj = self;
end