 load([ 'sphereinblock' ]);

[t,v,tmid] = img_to_t4a(img,[1,2]);
clear img
v(:,1)=dx*v(:,1);v(:,2)=dy*v(:,2);v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
clear coarsening_options;
 coarsening_options.stretch=1.25;
coarsening_options.desired_ts =mean([dx,dy,dz]);
f = t4_bdry(t(find(tmid==1),:));
bv =zeros(size(v,1),1);
bv(f)=1;
coarsening_options.bv=bv;
clear smoothing_options;

disp( ['Mesh size: initial ' num2str(Initial_number)])

tic;
[t,v,tmid] = coarsen(t,v,tmid,coarsening_options);
Elapsed =toc;
disp( ['Elapsed time ' num2str(Elapsed)])

f = t4_bdry(t(find(tmid==2),:));
smoothing_options.f=f;
smoothing_options.method='laplace';
[t,v] =smoothing(t,v,smoothing_options);

disp( ['Mesh size: final ' num2str(size(t,1))])

%  visualize_non_positive