% load([ 'pipe2' ]);
%load([ 'blockswhole1' ]);
 load([ 'earb1' ]);
% load([ 'smallBlock1' ]);
% load([ 'spheres1' ]);
% navw=subset_avw(avw,77:161,    86:173,    38:112);% data =avw.img(34:122,41:137,39:120);
% navw.img(find(navw.img~=23000)) = 0;
% navw = resample_avw(navw, 1);
% navw=subset_avw(avw,34:55,41:68,39:63); navw = pad_avw(navw,3,3,3,0);
[t,v] = img_to_t4(img,1);
v(:,1)=dx*v(:,1);
v(:,2)=dy*v(:,2);
v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
nlayers=4;
desired_ts =1.5*dx;

f = t4_bdry(t);
fvn =  vertex_neighbors([],f,v);
vn =  vertex_neighbors([],t,v);

npass=1;
for j=1:npass
    pv=v;
    v =  taubin_smoother(v,fvn,4,0.5,-0.5);
    fv =v;
    v =  taubin_smoother(v,vn,2,0.5,-0.5);
    for i= 1:length(fvn)
        if (~isempty(fvn {i}))
            v(i,:)= fv(i,:);
        end
    end

end

for iS1 =1:size(t,1)
    if (tetvol(v(t(iS1,:),:))<0),
        [' Volume: ' num2str(tetvol(v(t(iS1,:),:)))]
    end
end


fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' Before the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

f = t4_bdry(t);
bv =zeros(size(v,1),1);
for i=1:size(f,1)
    bv(f(i,:)) = true;
end

v2t = v_to_t4_map (size(v,1),t) ;
ts =zeros(size(t,1),1);
for i=1:size(t,1)
    [edge_lengths,ec] = t4_edge_lengths(v(t(i,:),:));
    ts(i) =max(edge_lengths);
end

for layer=1:nlayers
   
    while true
        [Ignore,IX] =sort(ts,'ascend');
        Change =  ~true;
        for i=1:length(IX)
            if  (ts(IX(i))<desired_ts)  &&    (sum(bv(t(IX(i),:)))==0)
                [edge_lengths,ec] = t4_edge_lengths(v(t(IX(i),:),:));
                [ml,mi] =min(edge_lengths);
                ml
                e= t(IX(i),ec(mi,:));
                [Success,t,v,v2t,ts] = collapse_edge (t,v,v2t,ts,e);
                if (Success)
                    Change = true;
                    break;
                end
            end
        end
        if  (~Change)
            break;
        end
    end
    %mark layer next to current boundary
    oldbv=bv;
    for i=1:size(bv,1)
        if oldbv(i)
            for j=v2t{i}
                bv(t(j,:))=true;
            end
        end
    end
    length(find(bv~=0))
     desired_ts=desired_ts*1.5;

end

[t,v] =  delete_entities (t,v);

f = t4_bdry(t);
fvn =  vertex_neighbors([],f,v);
vn =  vertex_neighbors([],t,v);

npass=1;
for j=1:npass
    pv=v;
    v =  taubin_smoother(v,fvn,4,0.5,-0.5);
    fv =v;
    v =  taubin_smoother(v,vn,2,0.5,-0.5);
    for i= 1:length(fvn)
        if (~isempty(fvn {i}))
            v(i,:)= fv(i,:);
        end
    end

end
disp( [' Mesh size: initial ' num2str(Initial_number), ', final ' num2str(size(t,1))])
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' After the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

for iS1 =1:size(t,1)
    if (tetvol(v(t(iS1,:),:))<0),
        [' Volume: ' num2str(tetvol(v(t(iS1,:),:)))]
    end
end
% %
%
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
validate_mesh(fens, gcells)
