% load([ 'pipe2' ]);
% load([ 'blockswhole1' ]);
 load([ 'earb1' ]);
% load([ 'smallBlock1' ]);
% load([ 'spheres1' ]);
% load([ 'holcub1' ]);
% load([ 'ablock7' ]);

[t,v] = img_to_t4a(img,1);%(1:2,1:2,1:2)
v(:,1)=dx*v(:,1);v(:,2)=dy*v(:,2);v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
stretch=1.15;
desired_ts =sqrt(dx^ 2+dy^ 2+dz^ 2);

[t,v] =smoothing(t,v);

Count =count_non_positive_volume (t,v);
disp([' Before the number of non-positive volume tetrahedra is = '...
    num2str(Count)])

fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' Before the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

disp( [' Mesh size: initial ' num2str(Initial_number)])

tic;
[t,v] = coarsen_layered2(t,v,desired_ts,stretch);
Elapsed =toc;
disp( [' Elapsed time ' num2str(Elapsed)])

[t,v] =smoothing(t,v);

disp( [' Mesh size: final ' num2str(size(t,1))])
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
feb = feblock (struct ('mater',[], 'gcells',gcells,...
    'integration_rule', tet_rule (1)));
disp([' After the volume is = '...
    num2str(measure(feb,geom,inline('1')))])

Count =count_non_positive_volume (t,v);
disp([' After the number of non-positive volume tetrahedra is = '...
    num2str(Count)])

% %
%
fens =fenodeset(struct('id',(1:size(v,1)),'xyz',v));
gcells =gcellset_T4(struct('conn',t));
validate_mesh(fens, gcells)
