function   draw_isosurface(self, gv, context)
    conns = get(self, 'conn'); % connectivity
    hconns=zeros(size(conns,1),8);
    hconns(:,1:4)=conns;
    hconns(:,5)=hconns(:,4);
    hconns(:,6)=hconns(:,4);
    hconns(:,7)=hconns(:,4);
    hconns(:,8)=hconns(:,4);
    hconns(:,4)=hconns(:,3);
    [f,v]= isosurf_faces(gcellset_H8, hconns, context.x, context.u, context.scalarfield, context.isovalue, 3);
    
    if (isfield(context,'color'))
        color =context.color;
    else
        color =[1,1,1]/2;
    end
    
    facealpha = 1;
    if (isfield(context,'facealpha'))
        facealpha = context.facealpha;
    end
    patch('Faces',f,'Vertices',v,'FaceColor',color,'EdgeColor','none','FaceAlpha', facealpha);
end
