% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'id'}, {'finite element node identifier, scalar'}};
            {{'dir'}, {'direction, scalar'}};
            {{'magn'}, {'magnitude, scalar'}};
            {{'kind'}, {'kind, interpreted by the client'}};
            {{'data'}, {'data, interpreted by the client'}};
            };
%       {{'nconn'}, {'number of individual connectivities in this set'}};
              return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'kind'
                val = self.kind;
            case 'data'
                val = self.data;
            case 'id'
                val = self.id;
            case 'dir'
                val = self.dir;
            case 'magn'
                val = self.magn;
            otherwise
                val = get(self.classbase,prop_name);
        end
    end
end
