font='Times';
Legends = {};
Data = {};
Style = {};

% loadv=[0;0;p];dir=3;uzex=5.426e-3;
% loadv=[0;p;0];dir=2;
uzex=6.938;


Data{end+1}=[
   22.0000   11.0000    5.5000    2.7500    1.3750
   4.847, 6.173, 6.673, 6.833, 6.891
];Style{end+1}='ko-';Legends{end+1} ='F-Bar SN Q';
Data{end+1}=[
   22.0000   11.0000    5.5000    2.7500    1.3750
   4.0605, 5.7504, 6.5034, 6.7704, 6.867
];Style{end+1}='ko--';Legends{end+1} ='F-Bar SN T';

%NICE-T4: number of equations =108
%     Normalized displacement =1.1916
%NICE-T4: number of equations =600
%     Normalized displacement =1.0971
%NICE-T4: number of equations =1764
%     Normalized displacement =1.0456
%NICE-T4: number of equations =3888
%     Normalized displacement =1.0258
Data{end+1}=[
  22.0000   11.0000    5.5000    2.7500
    4.4238    6.2045    6.8819    6.9742
];Style{end+1}='m^-';Legends{end+1} ='NICE-T4';
%NICE-H8: number of equations =108
%     Normalized displacement =0.89832
%NICE-H8: number of equations =600
%     Normalized displacement =0.95611
%NICE-H8: number of equations =1764
%     Normalized displacement =0.97652
%NICE-H8: number of equations =3888
%     Normalized displacement =0.98501
Data{end+1}=[
   22.0000   11.0000    5.5000    2.7500    1.3750
    2.7564    4.9692    6.2023    6.6380    6.8048
];Style{end+1}='md-';Legends{end+1} ='NICE-H8';

Data{end+1}=[
  44.0000   22.0000   11.0000    5.5000
    2.8655    5.3501    6.4636    6.7552
];Style{end+1}='mh-.';Legends{end+1} ='NICE-H27';
Data{end+1}=[
   44.0000   22.0000   11.0000
    5.2009    6.3634    6.6929
];Style{end+1}='r*--';Legends{end+1} ='NICE-H64';



for j=1:length(Data)
    data=Data{j};
    h=data(1,:); utip=data(2,:);
%     plot(h,utip,Style{j},'lineWIDTH', 2); hold on;
    loglog(44./h,abs(utip-uzex)/uzex,Style{j},'lineWIDTH', 2); hold on;
end

% set(gca,'XLim', [100, 1000]);
% set(gca,'YLim', [0.e-3, 2.25e-3]);
xlabel ('number of elements per side')
ylabel ('Displacement error')
legend(Legends,'Location','Southwest')
set(gca,'Position',[0.15 0.15 0.7 0.5]);
set_label_defaults
hold on; grid on; figure (gcf);
% saveas(gcf,[mfilename '.png']);
 printeps(gcf,[mfilename '.eps']);
%  close  all