% load([ 'spheres1' ]); load([ 'pipe2' ]); load([ 'blockswhole1' ]); load([ 'smallBlock1' ]);
% load([ 'holcub1' ]);
 %load([ 'earb1' ]);
%  load([ 'ablock5' ]);
 load([ 'Tutr9277cubicSplineRot165Lyaw_Masked2_LtEar_6.mat' ]);

[t,v,tmid] = img_to_t4a(img,[32000]);
v(:,1)=dx*v(:,1);v(:,2)=dy*v(:,2);v(:,3)=dz*v(:,3);
Initial_number = size(t,1);
options.stretch=1.5;
% options.desired_ts =sqrt(dx^ 2+dy^ 2+dz^ 2);
options.desired_ts =mean([dx,dy,dz]);
% bv=zeros(size(v,1),1); 
% vlist = v_select(v, struct ('box',[0 7 0 inf 0 inf], 'inflate',0.001*dx));
% bv (vlist)=1;
% options.bv =bv;
f = t4_interfaces(t,tmid,[0,1;0,2;1,2]);
bv=zeros(size(v,1),1); 
bv(unique(reshape(f,prod(size(f)),1))) =true;
options.bv =bv;

disp( ['Mesh size: initial ' num2str(Initial_number)])

tic;
[t,v,tmid]  = coarsen(t,v,tmid,options);

Elapsed =toc;
disp( ['Elapsed time ' num2str(Elapsed)])

smoothingoptions=[];
[ignore,v] =smoothing(t(find(tmid==2),:),v,smoothingoptions);

disp( ['Mesh size: final ' num2str(size(t,1))])

fens =fenodeset(struct('id',(1:size(v,1))','xyz',v));
gcells =gcellset_T4(struct('conn',double(t)));
validate_mesh(fens, gcells)
%  visualize_non_positive